
#include <limits.h>

#include "config.h"
#include "reduce_server.h"

tally_t init()
{
  tally_t t = { INT_MAX, INT_MAX };
  return t;
}

tally_t adjust(tally_t tally, int v)
{
  if (v < tally.second_smallest) {
    if (v < tally.smallest) {
      tally.second_smallest = tally.smallest;
      tally.smallest = v;
    } else {
      tally.second_smallest = v;
    }
  }

  return tally;
}

tally_t accum(tally_t tally, int i, data_t *myArray)
{
  return adjust(tally, myArray[i]);
}

tally_t combine(tally_t tally1, tally_t tally2)
{
  return adjust(adjust(tally1, tally2.smallest), tally2.second_smallest);
}

result_t reduceGen(tally_t tally)
{
  return tally.second_smallest;
}
